-- Basic clickin' 'n' draggin' 'n' droppin'
-- by hryx 2012
-- publicke domaine

function love.load()
	img_default = love.graphics.newImage('default.png')
	img_clicked = love.graphics.newImage('clicked.png')
	icon = {}
	icon.img = img_default
	icon.w = icon.img:getWidth()
	icon.h = icon.img:getHeight()
	icon.x = love.graphics.getWidth() / 2 - icon.w / 2
	icon.y = love.graphics.getHeight() / 2 - icon.h / 2
end

function love.update(dt)
	if icon.is_being_dragged then
		icon.x = love.mouse.getX() - icon.mouse_offset_x
		icon.y = love.mouse.getY() - icon.mouse_offset_y
	end
end

function love.draw()
	love.graphics.draw(icon.img, icon.x, icon.y)
end

function love.mousepressed(x, y, button)
	if button ~= 'l' then return end
	local icon = icon
	if x >= icon.x
	and x <= icon.x + icon.w
	and y >= icon.y
	and y <= icon.y + icon.h then
		icon.is_being_dragged = true
		icon.mouse_offset_x = x - icon.x
		icon.mouse_offset_y = y - icon.y
		icon.img = img_clicked
	end
end

function love.mousereleased(x, y, button)
	if button ~= 'l' then return end
	icon.is_being_dragged = false
	icon.img = img_default
end

function love.keypressed(k)
	if k == 'escape' or k == 'q' then
		love.event.push('q')
	end
end
